\section{Satisfying a~non-trivial congruence identity}

There are several Mal'cev characterizations of varieties that satisfy some
non-trivial congruence identity. An older one, called a~Hobby-McKenzie term (for
the definition we refer to \cite{hobby.mckenzie88} or \cite{kearnes.kiss13}),
and more recent by Kearnes and Kiss \cite{kearnes.kiss13}:

\begin{theorem}[{\cite[Theorems 5.28 and 7.15]{kearnes.kiss13}}]
  \label{thm:kearnes.kiss}
The following is equivalent for a~variety $\var V$.
\begin{enumerate}
  \item $\var V$ satisfies a~non-trivial congruence identity,
  \item $\var V$ satisfies an~idempotent Mal'cev condition that fails in the
  variety of semilattices,
  \item there exists $4$-ary terms $t_0,\dots,t_n$ such that the identities
    \begin{align*}
      t_0(x,y,z,w) &\equals x \text{ and } t_n(x,y,z,w) \equals w, \\
      t_i(x,y,y,y) &\equals t_{i+1}(x,y,y,y) \text{ for even $i$,} \\
      t_i(x,x,y,y) &\equals t_{i+1}(x,x,y,y) \text{ and }
      t_i(x,y,y,x) \equals t_{i+1}(x,y,y,x) \text{ for odd $i$}
    \end{align*}
  are satisfied in $\var V$. \qed
\end{enumerate}
\end{theorem}

We will refer to the terms in item (3) as to Kearnes-Kiss terms. Also note that
as a~byproduct of this characterization, Kearnes and Kiss proved that
an~idempotent variety satisfies a~non-trivial congruence identity if and only if
it is not interpretable in the variety of semilattices (this follows from the
equivalence of (1) and (2) in the above theorem).

\subsection{Coloring and linear varieties}

Kearnes and Kiss also proved that item (1) of Theorem \ref{thm:kearnes.kiss}
implies that the variety contains an algebra $\al A$ with a~compatible
(sometimes called commuting) semilattice operation, i.e., there is a~semilattice
operation $\join$ on $A$ such that its graph---the relation $\{ (a,b,a\join b) :
a,b\in A \}$ is a~compatible relation.  This suggests a~relational structure to
be used in the coloring description of this Mal'cev condition: the structure
$\rel S$ on $\{0,1\}$ with one ternary relation $J^{\rel S} = \{ (x,y,x \join y)
: x,y \in \{0,1\} \}$.  Note that the idempotent reduct of $\clo S$ is the same
as the clone of term operations of the semilattice $(\{0,1\}, \join)$
(see also \cite[Lemma~5.25]{kearnes.kiss13}).

\begin{proposition} \label{prop:coloring-congruence-identity}
  A~variety $\var V$ does not have Kearnes-Kiss terms if and only if it has
  strongly $\rel S$-colorable terms.
\end{proposition}

\begin{proof}
  As usual, let $\rel F$ denote the free structure in $\var V$ generated by
  $\rel S$. We will also identify a~binary term $b$ with an element
  $b(x_0,x_1)\in F$.
  Observe that, the relation $J^{\rel F}$ consists of triples $(r,s,t)$ such
  that there exists a~4-ary term $f$ satisfying $f(x,x,y,y) \equals r(x,y)$,
  $f(x,y,x,y) \equals s(x,y)$, and $f(x,y,y,y) \equals t(x,y)$.

  First, suppose that $\var V$ has Kearnes-Kiss terms. We want to proof that
  there is no strong coloring $c\colon \rel F \to \rel S$.
  By the definition of a~coloring and the relation $J$, we can deduce that for
  every triple $(r,s,t) \in J^{\rel F}$ if $c(r) = 0$ and $c(s) = 0$ then also
  $c(t) = 0$, and similarly if $c(t) = 0$ then both $c(r)$ and $c(s)$ are also
  $0$.
  By combining these two observations, one can prove by induction on $i$ that
  for any coloring $c$ with $c(x_0) = 0$ and any an~term $t_i$ from
  Kearnes-Kiss chain we have that $c(t_i(x_0,x_0,x_1,x_1)) = 0$,
  $c(t_i(x_0,x_1,x_0,x_1)) = 0$, and $c(t_i(x_0,x_1,x_1,x_1)) = 0$.
  This shows that any such coloring $c$ has to satisfy $c(x_1) = 0$ which
  contradicts that $c$ is strong.

  For the other implication, suppose that the variety $\var V$ does not have
  Kearnes-Kiss terms. We define a~mapping $c\colon F \to J$ in such a~way that
  $c(t) = 0$ if and only if this fact is forced by the argument in the previous
  paragraph, that is, there exists tuples $(s_i,t_i,r_i)\in J^{\var V}$, $i =
  1,\dots,n$ such that $s_0 = t_0 = x_0$, $r_i = r_{i+1}$ for even $i$, $s_i =
  s_{i+1}$ and $t_i = t_{i+1}$ for odd $i$, and $t = r_n$ for $n$ odd, or $t \in
  \{s_n,t_n\}$ for $n$ even.
  We claim that $c$ is a~coloring. Indeed, if $c(t) = 0$ and $(r,s,t) \in
  J^{\var V}$ for some $r,s\in F$, then also $c(r) = c(s) = 0$ by the
  definition, and if $c(t) = 1$ and $(r,s,t) \in J^{\var V}$ then either $c(r) =
  1$, or $c(s) = 1$, otherwise we would have defined $c(t) = 0$. In either case,
  we have $c(s) \join c(r) = c(t)$ which is what we wanted to prove.

  The coloring $c$ is strong: it maps $x_0$ to $0$ by definition, and also
  $c(x_1) = 1$, since the variety does not have Kearnes-Kiss terms.
\end{proof}

The fact that Kearnes-Kiss terms are not colorable by $\rel S$ can be also
argued using the arguments of \cite{kearnes.kiss13}: having Kearnes-Kiss terms
is an~idempotent linear Mal'cev condition that is not satisfiable in the variety
of semilattices, and existence of a~strong coloring would imply that it is
satisfied in $\clo S$, therefore also in the semilattice $(\{0,1\},\join)$.

\subsection{Idempotent varieties}

There is not much left to prove for idempotent varieties in this case. Let us
just once more reformulate results of Kearnes and Kiss in the following way:

\begin{corollary} \label{cor:kearnes.kiss}
An~idempotent variety does not satisfy a~non-trivial congruence identity if and
only if it contains an~algebra compatible with $\rel S$.
\end{corollary}

\begin{proof}
  Suppose that an~idempotent variety $\var V$ does not satisfy a~non-trivial
  congruence identity. Then by Theorem~\ref{thm:kearnes.kiss}, it is
  interpretable in the variety of semilattices. Therefore, it contains
  an~algebra $\al S$ with $S = \{0,1\}$ whose basic operations are term
  operations of the two-element semilattice $(S; \join)$. But all such term
  operations are compatible with the relation $J^{\rel S}$ which means that $\al
  S$ is compatible with $\rel S$.

  For the other implication, suppose that $\var V$ contains an~algebra $\al S$
  compatible with $\rel S$. If this is the case, one can directly see that the
  terms of $\var V$ are $\rel S$-colorable (define the coloring by taking the
  natural homomorphism from the free algebra generated by $S$ to $\al S$), and
  therefore it does not satisfy a~non-trivial congruence identity by
  Proposition~\ref{prop:coloring-congruence-identity}.
\end{proof}

\subsection{Proof of Theorem \ref{thm:overview-introduction}(iii)}
  The argumentation here follows a~familiar pattern. First, we argue that any
  variety $\var V$ that is either linear, or idempotent has an~algebra
  compatible with $\rel S$: the linear case follows from
  Proposition~\ref{prop:coloring-congruence-identity} and
  Lemma~\ref{lem:linear-varieties}, the idempotent case from
  Corollary~\ref{cor:kearnes.kiss}.

  Next, given that both $\var V$ and $\var W$ do not satisfy a~congruence
  identity and are either linear, or idempotent, we know that both varieties
  contain an algebra compatible with $\rel S$, therefore also $\var V \join \var
  W$ does.  This shows in particular that $\var V \join \var W$ has $\rel
  S$-colorable terms, therefore it does not satisfy a~non-trivial congruence
  identity by Proposition~\ref{prop:coloring-congruence-identity}. \qed
